//
//  ChatInteractor.swift
//  VKExt
//
//  Created programmist_NA on 31.05.2020.
//  Copyright © 2020 ___ORGANIZATIONNAME___. All rights reserved.
//
//  Template generated by Juanpe Catalán @JuanpeCMiOS
//

import UIKit
import SwiftyJSON
import SwiftyVK
import RealmSwift

class ChatInteractor: ChatInteractorProtocol {
    weak var presenter: ChatPresenterProtocol?
    var chatMessagesCount: Int = 0
    
    func start(offset: Int, peerId: Int, count: Int) {
        getHistory(offset: offset, peerId: peerId, count: count)
    }
    
    func getHistory(offset: Int, peerId: Int, count: Int) {
        VK.API.Messages.getHistory([.peerId: "\(peerId)", .offset: "\(offset)", .count: "\(count)", .extended: "1"])
        .configure(with: Config.init(httpMethod: .GET, language: Language(rawValue: "ru")))
        .onSuccess { response in
            self.chatMessagesCount = JSON(response)["count"].intValue
            DispatchQueue(label: "messages.getHistory", qos: .background).async {
                autoreleasepool {
                    let realm = try! Realm()
                    let items = JSON(response)["items"].arrayValue
                    let conversation = JSON(response)["conversations"].arrayValue.first!
                    try! realm.write {
                        for item in items {
                            let message = Message(message: item, conversation: conversation)
                            realm.add(message, update: .modified)
                        }
                    }
                    self.removeMissingMessages()
                }
            }
        }
        .onError { vkError in
        }
        .send()
    }
    
    func removeMissingMessages() {
        let realm = try! Realm()
        let missingMessages = realm.objects(Message.self).filter { $0.isSending }
        try! realm.write {
            realm.delete(missingMessages)
        }
    }
    
    func sendMessage(message: String, peerId: Int, randomId: Int64) {
        VK.API.Messages.send([.message: message, .peerId: "\(peerId)", .randomId: "\(randomId)"])
        .configure(with: Config.init(httpMethod: .POST, language: Language(rawValue: "ru")))
        .onSuccess { response in
            print("success: \(JSON(response))")
        }
        .onError { vkError in
        }
        .send()
    }
    
    func removeMessage(messageId: Int, removeFromAll: Bool) {
        VK.API.Custom.method(name: "messages.delete", parameters: ["message_ids" : "\(messageId)", "delete_for_all" : "\(Int(truncating: NSNumber(value: removeFromAll)))"])
        .configure(with: Config.init(httpMethod: .POST, language: Language(rawValue: "ru")))
        .onSuccess { response in
            DispatchQueue(label: "messages.getHistory", qos: .background).async {
                autoreleasepool {
                    let realm = try! Realm()
                    guard let message = realm.objects(Message.self).filter("id == %@", messageId).first else { return }
                    guard !message.isInvalidated else { return }
                    try! realm.write {
                        realm.delete(message)
                    }
                }
            }
        }
        .onError { vkError in
            DispatchQueue(label: "messages.getHistory", qos: .background).async {
                autoreleasepool {
                    let realm = try! Realm()
                    guard let message = realm.objects(Message.self).filter("id == %@", messageId).first else { return }
                    guard !message.isInvalidated else { return }
                    try! realm.write {
                        realm.delete(message)
                    }
                }
            }
        }
        .send()
    }
    
    func edit(message: String, messageId: Int, peerId: Int) {
        VK.API.Custom.method(name: "messages.edit", parameters: ["message_id" : "\(messageId)", "message" : message, "peer_id" : "\(peerId)"])
        .configure(with: Config.init(httpMethod: .POST, language: Language(rawValue: "ru")))
        .onSuccess { response in
            print(JSON(response))
        }
        .onError { vkError in
        }
        .send()
    }
}
